﻿//---スキル[瞬殺]---作:1-239--------------
//
//【概要】
//瞬殺のスキルを導入します
//
//【使用方法】
//カスタムスキルのキーワードに[One-kill]と入力。
//このスキルが発動時すると敵を必ず倒します。
//ちなみに優先度は
//生き残りスキル＞瞬殺　・　ダメージ無効スキル＞瞬殺
//
//カスタムスキルのキーワードに[One-kill()]と入力。
//このスキルが発動時すると敵のＨＰを"１"にします。
//発動しなければ敵を倒せる状況でも発動したら敵のＨＰを"１"にします。
//つまりは瞬殺(笑)
//
//5/29 とりあえず公開
//  
//---------------------------------------------
(function() {
var alias1 = SkillRandomizer.isCustomSkillInvokedInternal;
SkillRandomizer.isCustomSkillInvokedInternal = function(active, passive, skill, keyword) {
	if (keyword === 'One-kill') {
		return this._isSkillInvokedInternal(active, passive, skill);
	}
	if (keyword === 'One-kill()') {
		return this._isSkillInvokedInternal(active, passive, skill);
	}
	return alias1.call(this, active, passive, skill, keyword);
};

var alias2 = AttackEvaluator.HitCritical.calculateDamage;
AttackEvaluator.HitCritical.calculateDamage = function(virtualActive, virtualPassive, entry) {
	var damage = alias2.call(this, virtualActive, virtualPassive, entry);
	
	// スキルが発動した場合は、ダメージに相手のHPを代入する
	if (SkillControl.checkAndPushCustomSkill(virtualActive.unitSelf, virtualPassive.unitSelf, entry, true, 'One-kill') !== null) {
	return virtualPassive.hp;
	}
	if (SkillControl.checkAndPushCustomSkill(virtualActive.unitSelf, virtualPassive.unitSelf, entry, true, 'One-kill()') !== null) {
	return virtualPassive.hp - 1;
	}

	return damage;

};

})();
