﻿//---スキル[絶対回避]---作:1-239--------------
//
//【概要】
//命中100%でも必ず回避するスキルを設定します
//正し必中が同時に発動した場合無効となります
//
//【使用方法】
//スキルカスタム→TRUEavoid
//
//6/18 とりあえず公開
//  
//---------------------------------------------

(function() {

var alias1 = SkillRandomizer.isCustomSkillInvokedInternal;
SkillRandomizer.isCustomSkillInvokedInternal = function(active, passive, skill, keyword) {
	if (keyword === 'TRUEavoid') {
		// 発動型でない場合は、単純にtrueを返すだけでよい
		return this._isSkillInvokedInternal(active, passive, skill);
	}
	
	return alias1.call(this, active, passive, skill, keyword);
};

var alias2 = AttackEvaluator.HitCritical.isHit;
AttackEvaluator.HitCritical.isHit = function(virtualActive, virtualPassive, attackEntry) {
		var active = virtualActive.unitSelf;
		var passive = virtualPassive.unitSelf;
		
		if (SkillControl.checkAndPushSkill(active, passive, attackEntry, true, SkillType.TRUEHIT) !== null) {
			// 攻撃が必ず当たるスキルのためtrueを返す
			return true;
		}
		if (SkillControl.checkAndPushCustomSkill(passive ,active , attackEntry, false, 'TRUEavoid') !== null) {
			// 攻撃が必ず当たるスキルのためtrueを返す
			return false;
		}

		// 命中するかどうかは確率で計算
		return this.calculateHit(virtualActive, virtualPassive, attackEntry);
};

})();
