﻿/*--------------------------------------------------------------------------
統合Cal-達人回避 作:1-239

【概要】
FE覚醒の〇殺し・〇の達人スキルとベルサガの〇回避を設定するスクリプト
武器のカスタムに{wtype}を設定してください

(例では0(剣),1(槍),2(斧),3(弓),4(魔法)として定義しています。)

〇殺し　[killer_0]や[killer_2]の用に記述(剣殺し・斧殺し)
相手が数値の武器を装備している場合 命中・回避+{param_bonus}の値

〇回避　[iveid_1]や[iveid_3]の用に記述(槍回避・弓回避)
数値の武器を装備した相手と戦う時、相手の命中上限が{param_bonus}の値になる

〇の達人　[master_0]や[master_4]のように記述(剣の達人・魔の達人)
数値の武器を装備している時ダメ+{param_bonus}の値

それ以上作りたい場合は
var count = 4;の所の数値を変更してください
---------------------------------*/
(function () { 

var Buster = {
chackweapon: function(active, passive, weapon) {

	var buster = 0;
	var wpt = ItemControl.getEquippedWeapon(passive);
	var count = 4;

	for (i = 0; i < count; i++) {
	var word = 'killer_'+i;

	//殺しスキルを所持してるか
	var skill = SkillControl.getPossessionCustomSkill(active,word);
	if(skill){

	//武器装備中ならタイプ代入
	if (wpt !== null){
	wptype = passive.getItem(0).custom.wtype;
	var bonus = skill.custom.param_bonus;
	if(wptype == i){buster += bonus;}
			}
		}

	var skill = SkillControl.getPossessionCustomSkill(passive,word);
	if(skill){

	if (wpt !== null){
	wptype = active.getItem(0).custom.wtype;
	var bonus = skill.custom.param_bonus;
	if(wptype == i){buster -= bonus;}}} 
}

return buster;

},

chackiveid: function(active, passive, weapon, hit) {

	var count = 4;

	for (i = 0; i < count; i++) {
	var word = 'iveid_'+i;

	//剣回避スキルを所持してるか
	var skill = SkillControl.getPossessionCustomSkill(passive,word);
	if (skill){
	wptype = active.getItem(0).custom.wtype;
	var bonus = skill.custom.param_bonus;
	if(wptype == i){if(hit >= bonus){
	hit = bonus;}}}}

return hit;

},

chackmuster: function(unit){
	var master = 0;
	var wpt = ItemControl.getEquippedWeapon(unit); 
	var count = 4;

	if( wpt !== null ){

	for (i = 0; i < count; i++) {
	var word = 'master_'+i;
	var skill = SkillControl.getPossessionCustomSkill(unit,word);
	if (skill) {
	wpt = unit.getItem(0).custom.wtype;
	var bonus = skill.custom.param_bonus;
	if(wpt == i){master = bonus;}}
}}
return master;}

};

//以下計算式に数値を追加する処理

var alias1 = AbilityCalculator.getPower;
AbilityCalculator.getPower = function(unit, weapon) {

	var pow = alias1.call(this, unit, weapon);

	// スキル[達人]の処理
	pow += Buster.chackmuster(unit);

	return Math.floor(pow);
}

var alias2 = HitCalculator.calculateSingleHit;
HitCalculator.calculateSingleHit = function(active, passive, weapon, totalStatus) {
	var hit = alias2.call(this, active, passive, weapon, totalStatus);

	hit += Buster.chackweapon(active, passive, weapon);

	return hit;
}

var alias3 = HitCalculator.calculateHit;
HitCalculator.calculateHit = function(active, passive, weapon, activeTotalStatus, passiveTotalStatus) {

	var hit = alias3.call(this, active, passive, weapon, activeTotalStatus, passiveTotalStatus);

	var percent = Buster.chackiveid(active, passive, weapon, hit);

	return percent;
}

})(); 
