﻿/*--------------------------------------------------------------------------
  発動型スキルの実装例です。
　このサンプルプラグインが万能すぎて困る
  
  使用方法:
　武器破壊 [Weapon_break] 相手の装備している武器の耐久を自分のレベル分減少させる
　スリ取る [auto_thief] 相手の装備していない持ち物をランダムに一つ奪い取る
			相手が武器しか持っていない・自分の持ち物が満タンの時は発動しません
			アイテム入手ウィンドウ…？知らんな
  作成者:1-239
  
  更新履歴:2016/01/24 K
--------------------------------------------------------------------------*/
(function() {

var alias1 = SkillRandomizer.isCustomSkillInvokedInternal;
SkillRandomizer.isCustomSkillInvokedInternal = function(active, passive, skill, keyword) {

	if (keyword === 'Weapon_break') {
		return this._isSkillInvokedInternal(active, passive, skill);
	}

	if (keyword === 'auto_thief') {
		return this._isSkillInvokedInternal(active, passive, skill);
	}

	return alias1.call(this, active, passive, skill, keyword);
};

var alias2 = AttackEvaluator.HitCritical.calculateDamage;
AttackEvaluator.HitCritical.calculateDamage = function(virtualActive, virtualPassive, entry) {
	var damage = alias2.call(this, virtualActive, virtualPassive, entry);

	var active = virtualActive.unitSelf;
	var passive = virtualPassive.unitSelf;

	if (SkillControl.checkAndPushCustomSkill(virtualActive.unitSelf, virtualPassive.unitSelf, entry, true, 'Weapon_break') !== null) {

	var wpt = ItemControl.getEquippedWeapon(passive);
	if( wpt !== null ){
	var item = passive.getItem(0).getLimit();
	var value = active.getLv();

	var limit = item - value;
	if(limit <= 0){limit = 0;}
	passive.getItem(0).setlimit(limit);
		}
	}

	var unitItem = UnitItemControl.getPossessionItemCount(active);
	var maxCount = DataConfig.getMaxUnitItemCount() - 1;

	if(maxCount >= unitItem){

	var count = UnitItemControl.getPossessionItemCount(passive);
	if(count >= 2){

	if (SkillControl.checkAndPushCustomSkill(virtualActive.unitSelf, virtualPassive.unitSelf, entry, true, 'auto_thief') !== null) {
	count -= 1;
	var n = Probability.getRandomNumber() % count;
	n += 1;
	var item = passive.getItem(n);
	UnitItemControl.setItem(active, unitItem, item);
	UnitItemControl.cutItem(passive, n);
			}
		}
	}

	return damage;
};

})();
