﻿//---2枚目にステート耐性表示---作:1-239--------------
//
//【概要】
//ユニットメニューの2ページ目にステート耐性表示を表示します
//
//【使用方法】
//state-plus.jsを導入してこれを突っ込むだけ
//
//また、ステートに{notdrow}を設定すると絵画されなくなります
//
//---------------------------------------------

(function() {

var alias1 = UnitMenuScreen._configureBottomWindows;
UnitMenuScreen._configureBottomWindows = function(groupArray) {
	alias1.call(this, groupArray);
	
	groupArray.appendWindowObject(UnitMenuBottomSecondWindow, this);
};

var UnitMenuBottomSecondWindow = defineObject(BaseWindow,
{
	_unit: null,

	setUnitMenuData: function() {
	},
	
	changeUnitMenuTarget: function(unit) {
		UnitMenuTopWindow._unit = unit;
	},
	
	moveWindowContent: function() {
	return MoveResult.CONTINUE;
	},
	
	drawWindowContent: function(x, y) {
	var cr = UnitMenuTopWindow._unit;
	var list = root.getBaseData().getStateList();
	var max = list.getCount();
	var count = 1;
	var textui = this.getWindowTextUI();
	var color = textui.getColor();
	var font = textui.getFont();
	var length = -1;

	var icon_siz = 24;		// アイコン表示幅
	TextRenderer.drawText(x, y,'　　　ステート耐性', length, color, font);
	for (i = 0; i < max ; i++) {
	var state = root.getBaseData().getStateList().getData(i);
	var Name = state.getName();
	var Gurad = Probability.getreduse(cr,state);
	var handle = state.getIconResourceHandle();
	if(typeof state.custom.notdrow !== 'number'){
	if(count == 10){x += 210;count = 0;}
	GraphicsRenderer.drawImage(x, y + (count * 20) - 5 , handle, GraphicsType.ICON);
	TextRenderer.drawText(x + icon_siz, y + (count * 20),Name, length, color, font);
	TextRenderer.drawText(x + icon_siz + 120, y + (count * 20) ,'|', length, color, font);
	TextRenderer.drawText(x + icon_siz + 140, y + (count * 20) ,Gurad+'%', length, color, font);
	count += 1;}
	}

	},
	
	getWindowWidth: function() {
		return 450;
	},
	
	getWindowHeight: function() {
		return DefineControl.getUnitMenuBottomWindowHeight();
	},
	
	setHelpMode: function() {
		return false;
	},
	
	isHelpMode: function() {
		return false;
	},
	
	isTracingHelp: function() {
		return false;
	},
	
	getHelpText: function() {
		return '';
	}
}
);

})();